{*************************************************************************
              EXEMPLO DE USO DA DLL dms_nfse.dll

 Obs: Para fazer chamada a Dll a mesma dever estar no pasta system32 do windows.

**************************************************************************}

unit FrmTeste;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    BtnCriaRemessa: TButton;
    BtnConsultaLote: TButton;
    BtnConsultaNota: TButton;
    BtnConSeqRPS: TButton;
    procedure BtnConSeqRPSClick(Sender: TObject);
    procedure BtnConsultaNotaClick(Sender: TObject);
    procedure BtnConsultaLoteClick(Sender: TObject);
    procedure BtnCriaRemessaClick(Sender: TObject);
  end;

//Procedure usada para passar a URL do WebService
procedure setURL( varsRPS_HTTPSURL :PChar; varsRPS_HTTPSWSDL: PChar ); stdcall ;

//Funo para setar o caminho do arquivo XML temporario criado. Caso queira grara arquivos XML de remessa antes de enviar. caso no queira gravar, no  necessrio fazer chamada a essa funo
function setGravaArquivoXML( Caminho: PChar ):Integer ; stdcall ;
{ A dll ira gravar na pasta um arquivo para cada servico de acordo com o padrao de nomes abaixo :
   remessa-yyyymmdd-HH-MM-SS.xml
   retorno_remessa-yyyymmdd.xml
   remessa_consultalote-yyyymmdd.xml
   retorno_consultalote-yyyymmdd.xml
   remessa_consultanotas-yyyymmdd.xml
   retorno_consultanotas-yyyymmdd.xml
}

//OBS: Todas as funes listas abaixo retornam ZERO caso nao tenha ocorrido erro , e caso tenha ocorrido algum erro retorna o cdigo do erro.

//Funo para criar o lote de remessa, em cada novo lote, em cada nova remessa  necessrio chamar essa funo para criar o lote.
function CriarRemessa( CodCidade: Integer ;
                       CPFCNPJRemetente: PChar;
                       RazaoSocialRemetente: PChar): Integer ; stdcall ;

//Funao para informar os dados de cada RPS
function RPSRemessa( InscricaoMunicipalPrestador: PChar ;
                     RazaoSocialPrestador: PChar ;
                     TipoRPS : PChar ;
                     SerieRPS: PChar ;
                     NumeroRPS : Integer ;
                     DataEmissaoRPS : PChar ;
                     SituacaoRPS : PChar ;
                     SerieRPSSubstituido: PChar ;
                     NumeroRPSSubstituido : Integer ;
                     NumeroNFSeSubstituida : Integer ;
                     DataEmissaoNFSeSubstituida : PChar ;
                     SeriePrestacao: PChar ;
                     InscricaoMunicipalTomador  : PChar ;
                     CPFCNPJTomador  : PChar ;
                     RazaoSocialTomador : PChar ;
                     TipoLogradouroTomador : PChar ;
                     LogradouroTomador : PChar ;
                     NumeroEnderecoTomador : PChar ;
                     TipoBairroTomador: PChar ;
                     BairroTomador  : PChar ;
                     CidadeTomador  : Integer ;
                     CidadeTomadorDescricao: PChar ;
                     CEPTomador : PChar ;
                     EmailTomador  : PChar ;
                     CodigoAtividade: PChar ;
                     AliquotaAtividade : Double ;
                     TipoRecolhimento  : PChar ;
                     MunicipioPrestacao : Integer ;
                     MunicipioPrestacaoDescricao: PChar ;
                     Operacao   : PChar ;
                     Tributacao : PChar ;
                     ValorPIS    : Double ;
                     ValorCOFINS : Double ;
                     ValorINSS   : Double ;
                     ValorIR     : Double ;
                     ValorCSLL   : Double ;
                     AliquotaPIS : Double ;
                     AliquotaCOFINS : Double ;
                     AliquotaINSS : Double ;
                     AliquotaIR   : Double ;
                     AliquotaCSLL : Double ;
                     DescricaoRPS : PChar ;
                     DDDPrestador : PChar ;
                     TelefonePrestador : PChar ;
                     DDDTomador        : PChar ;
                     TelefoneTomador  : PChar ;
                     MotCancelamento : PChar) : Integer ; stdcall ;
//Funo para passar os dados de cada item do RPS
function RPSItem( DiscriminacaoServico: PChar ;
					        Quantidade: Double ;
					        ValorUnitario: Double ;
					        ValorTotal: Double  ): Integer ; stdcall ;

//Funo para passar os dado das dedues do RPS
function RPSDeducao( DeducaoPor: PChar ;
					           TipoDeducao: PChar ;
					           CPFCNPJReferencia: PChar ;
					           NumeroNFReferencia: Integer ;
					           ValorTotalReferencia: Double ;
					           PercentualDeduzir: Double ;
					           ValorDeduzir: Double  ): Integer ; stdcall ;

//Funo para finalizar lote e enviar declarao
function EnviarDeclaracao(    DocAssinatura : PChar ;
                          var Assincrono: PChar;
                          var Sucesso : PChar ;
		                      var NumeroLote: Integer ;
                          var QtdNotasProcessadas : Integer ;
                          var ValorTotalServicos: Double ;
                          var ValorTotalDeducoes:Double;
                          var Erros: Integer;
                          var Alertas: Integer): Integer ; stdcall ;

//Caso tenha algum Erro de retorno no envio da declarao ou na consulta de lote  pega os dados do erro.
function ErrosRetorno( ErroItem:Integer;
                       var Codigo: Integer;
                       var Descricao: PChar;
                       var InscricaoPrestador : PChar;
                       var SerieRPS: PChar ;
                       var NumeroRPS: Integer;
                       var DataEmissaoRPS:PChar;
                       var RazaoSocialPrestador: PChar ):Integer; stdcall ;

//Caso tenha algum Alerta de retorno no envio da declarao ou na consulta de lote  pega os dados do erro.
function AlertasRetorno( ErroItem:Integer;
                       var Codigo: Integer;
                       var Descricao: PChar;
                       var InscricaoPrestador : PChar;
                       var SerieRPS: PChar ;
                       var NumeroRPS: Integer;
                       var DataEmissaoRPS:PChar;
                       var RazaoSocialPrestador: PChar ):Integer; stdcall ;

//Se o servico for sincrono no envio da declarao ele retorna a quantidade de notas processadas,
//Pode-se usar esta funo para pegar os PPS do retorno.
function NfseRetorno( RetornoItem : Integer ;
                     var InscricaoPrestador: PChar ;
                     var NumeroNFe: Integer ;
                     var CodigoVerificacao: PChar ;
                     var RazaoSocialPrestador: PChar ;
                     var SerieRPS : PChar ;
				             var NumeroRPS: Integer ;
				             var DataEmissaoRPS : PChar ) :Integer ; stdcall;

//Funo para buscar as informaes de lote,
//aps o envio da declarao a funo com a funo EnviarDeclarao que retorno o nmero do lote.
//pode ser consultar os dados do processamento do lote pela ConsultarLote, caso o lote ainda no estiver processado
//o parametro Sucesso retorna falso.

function ConsultarLote(    CodCidade: Integer ;
                           CPFCNPJRemetente: PChar ;
                           NumeroLote: Integer ;
                       var Sucesso: PChar;
                       var DataEnvioLote: PChar;
                       var QtdNotasProcessadas: Integer;
                       var TempoProcessamento: PChar;
                       var ValorTotalServicos: Double;
                       var ValotTotalDeducoes: Double ;
                       var Alertas: Integer;
                       var Erros: Integer):Integer; stdcall;

//Fuao para consultar Notas do Lote, apos consultar lote pela funo ConsultarLote, pode-se obter os dados das notas.
function ConsultarNFSeLote( NrItem:Integer;
                           var InscricaoPrestador: PChar;
			                     var NumeroNFe: Integer ;
			                     var CodigoVerificacao:PChar ;
			                     var SerieRPS:PChar ;
			                     var NumeroRPS: Integer;
			                     var DataEmissaoRPS: PChar ;
			                     var RazaoSocialPrestador: PChar ;
                           var TipoRecolhimento: PChar ;
			                     var ValorDeduzir :Double;
			                     var ValorTotal : Double;
			                     var Aliquota : Double ):Integer; stdcall;

//Funo para consultar notas geradas em determinado periodo.
function ConsultarNotas(   CodCidade: Integer ;
                           CPFCNPJRemetente: PChar ;
                           InscricaoMunicipalPrestador: PChar ;
                           DataInicio: PChar;
                           DataTermino: PChar;
                       var QtdNotas : Integer ):Integer; stdcall;


//Funo para obter os dados das notas, aps consultar pela funo ConsultarNotas.
function NotaConsultarNotas(  PosNotaConsulta : Integer ;
                             var NumeroNota : Integer ;
                             var DataProcessamento: PChar ;
                             var NumeroLote : Integer ;
                             var CodigoVerificacao : PChar ;
                             var Assinatura : PChar ;
                             var InscricaoMunicipalPrestador: PChar ;
                             var RazaoSocialPrestador: PChar ;
                             var TipoRPS: PChar ;
                             var SerieRPS : PChar ;
                             var NumeroRPS : Integer ;
                             var DataEmissaoRPS : PChar ;
                             var SituacaoRPS : PChar ;
                             var SerieRPSSubstituido :PChar ;
                             var NumeroRPSSubstituido : Integer ;
                             var NumeroNFSeSubstituida :Integer ;
                             var DataEmissaoNFSeSubstituida  : PChar ;
                             var SeriePrestacao :PChar ;
                             var InscricaoMunicipalTomador : PChar ;
                             var CPFCNPJTomador : PChar ;
                             var RazaoSocialTomador :PChar ;
                             var TipoLogradouroTomador :PChar ;
                             var LogradouroTomador :PChar;
                             var NumeroEnderecoTomador :PChar ;
                             var TipoBairroTomador: PChar ;
                             var BairroTomador: PChar ;
                             var CidadeTomador:PChar ;
                             var CidadeTomadorDescricao: PChar ;
                             var CEPTomador:PChar ;
                             var EmailTomador:PChar ;
                             var CodigoAtividade: PChar ;
                             var AliquotaAtividade: Double ;
                             var TipoRecolhimento :PChar ;
                             var MunicipioPrestacao: Integer ;
                             var MunicipioPrestacaoDescricao: PChar ;
                             var Operacao: PChar ;
                             var Tributacao: PChar ;
                             var ValorPIS : Double ;
                             var ValorCOFINS:Double ;
                             var ValorINSS : Double ;
                             var ValorIR : Double ;
                             var ValorCSLL : Double ;
                             var AliquotaPIS : Double ;
                             var AliquotaCOFINS : Double;
                             var AliquotaINSS : Double ;
                             var AliquotaIR : Double ;
                             var AliquotaCSLL : Double ;
                             var DescricaoRPS : PChar ;
                             var DDDPrestador  : PChar ;
                             var TelefonePrestador : PChar ;
                             var DDDTomador : PChar ;
                             var TelefoneTomador : PChar ;
                             var MotCancelamento : PChar ;
                             var Deducoes : Integer ;
                             var Itens : Integer ):Integer; stdcall;

//Funo para obter a Deduo de cadas nota retornada pela funo  NotaConsultarNotas
function DecucaoNotaConsultarNotas( PosNotaConsulta: Integer ;
                                   PosDeducaoNotaConsulta: Integer ;
                                   var DeducaoPor :PChar ;
					                         var TipoDeducao: PChar ;
					                         var CPFCNPJReferencia: PChar ;
					                         var NumeroNFReferencia: Integer ;
					                         var ValorTotalReferencia : Double ;
					                         var PercentualDeduzir: Double ;
					                         var ValorDeduzir: Double): Integer; stdcall;

//Funo para obter a Deduo de cadas nota retornada pela funo  NotaConsultarNotas
function ItemNotaConsultarNotas( PosNotaConsulta: Integer ;
                                PosItemNotaConsulta: Integer ;
                                var DiscriminacaoServico: PChar ;
					                      var Quantidade: Double ;
					                      var ValorUnitario: Double ;
                                var ValorTotal: Double): Integer; stdcall;
//Consulta Sequencial do RPS - Pega o Numero do Ultimo RPS convertido pelo contribuinte
function ConsultarSeqRps( CodCidade: Integer ;
                         CPFCNPJRemetente: PChar ;
                         InscricaoMunicipalPrestador: PChar ;
                     var NroUltimoRps : Integer ):Integer; stdcall;


//Caso tenha retornado um erro em alguma das funes pode se consultar a descrio do erro ocorrido nesta funo.
function ErroRetorno(CodErro: Integer ): Pchar ; stdcall;
function ErroRetorno2(CodErro: Integer ): Integer ; stdcall;

var
  Form1: TForm1;

implementation


procedure setURL( varsRPS_HTTPSURL :PChar; varsRPS_HTTPSWSDL: PChar ); external 'dms_nfse.dll';


function setGravaArquivoXML( Caminho: PChar ):Integer ; external 'dms_nfse.dll';

function CriarRemessa( CodCidade: Integer ;
		                   CPFCNPJRemetente: PChar;
                       RazaoSocialRemetente: PChar ): Integer ; external 'dms_nfse.dll';


function RPSRemessa( InscricaoMunicipalPrestador: PChar ;
                     RazaoSocialPrestador: PChar ;
                     TipoRPS : PChar ;
                     SerieRPS: PChar ;
                     NumeroRPS : Integer ;
                     DataEmissaoRPS : PChar ;
                     SituacaoRPS : PChar ;
                     SerieRPSSubstituido: PChar ;
                     NumeroRPSSubstituido : Integer ;
                     NumeroNFSeSubstituida : Integer ;
                     DataEmissaoNFSeSubstituida : PChar ;
                     SeriePrestacao: PChar ;
                     InscricaoMunicipalTomador  : PChar ;
                     CPFCNPJTomador  : PChar ;
                     RazaoSocialTomador : PChar ;
                     TipoLogradouroTomador : PChar ;
                     LogradouroTomador : PChar ;
                     NumeroEnderecoTomador : PChar ;
                     TipoBairroTomador: PChar ;
                     BairroTomador  : PChar ;
                     CidadeTomador  : Integer ;
                     CidadeTomadorDescricao: PChar ;
                     CEPTomador : PChar ;
                     EmailTomador  : PChar ;
                     CodigoAtividade: PChar ;
                     AliquotaAtividade : Double ;
                     TipoRecolhimento  : PChar ;
                     MunicipioPrestacao : Integer ;
                     MunicipioPrestacaoDescricao: PChar ;
                     Operacao   : PChar ;
                     Tributacao : PChar ;
                     ValorPIS    : Double ;
                     ValorCOFINS : Double ;
                     ValorINSS   : Double ;
                     ValorIR     : Double ;
                     ValorCSLL   : Double ;
                     AliquotaPIS : Double ;
                     AliquotaCOFINS : Double ;
                     AliquotaINSS : Double ;
                     AliquotaIR   : Double ;
                     AliquotaCSLL : Double ;
                     DescricaoRPS : PChar ;
                     DDDPrestador : PChar ;
                     TelefonePrestador : PChar ;
                     DDDTomador        : PChar ;
                     TelefoneTomador  : PChar ;
                     MotCancelamento : PChar ) : Integer ; external 'dms_nfse.dll';

function RPSDeducao( DeducaoPor: PChar ;
					           TipoDeducao: PChar ;
					           CPFCNPJReferencia: PChar ;
					           NumeroNFReferencia: Integer ;
					           ValorTotalReferencia: Double ;
					           PercentualDeduzir: Double ;
					           ValorDeduzir: Double  ): Integer ; external 'dms_nfse.dll';

function RPSItem( DiscriminacaoServico: PChar ;
					        Quantidade: Double ;
					        ValorUnitario: Double ;
					        ValorTotal: Double  ): Integer ; external 'dms_nfse.dll';




function EnviarDeclaracao(    DocAssinatura : PChar ;
                          var Assincrono: PChar;
                          var Sucesso : PChar ;
		                      var NumeroLote: Integer ;
                          var QtdNotasProcessadas : Integer ;
                          var ValorTotalServicos: Double ;
                          var ValorTotalDeducoes:Double;
                          var Erros: Integer;
                          var Alertas: Integer): Integer ; external 'dms_nfse.dll';

function ErrosRetorno( ErroItem:Integer;
                         var Codigo: Integer;
                         var Descricao: PChar;
                         var InscricaoPrestador : PChar;
                         var SerieRPS: PChar ;
                         var NumeroRPS: Integer;
                         var DataEmissaoRPS:PChar;
                         var RazaoSocialPrestador: PChar ):Integer; external 'dms_nfse.dll';

function AlertasRetorno( ErroItem:Integer;
                         var Codigo: Integer;
                         var Descricao: PChar;
                         var InscricaoPrestador : PChar;
                         var SerieRPS: PChar ;
                         var NumeroRPS: Integer;
                         var DataEmissaoRPS:PChar;
                         var RazaoSocialPrestador: PChar ):Integer; external 'dms_nfse.dll';


function NfseRetorno( RetornoItem : Integer ;
                     var InscricaoPrestador: PChar ;
                     var NumeroNFe: Integer ;
                     var CodigoVerificacao: PChar ;
                     var RazaoSocialPrestador: PChar ;
                     var SerieRPS : PChar ;
				             var NumeroRPS: Integer ;
				             var DataEmissaoRPS : PChar ) :Integer ; external 'dms_nfse.dll';
function ConsultarLote(     CodCidade: Integer ;
                           CPFCNPJRemetente: PChar ;
                           NumeroLote: Integer ;
                       var Sucesso: PChar;
                       var DataEnvioLote: PChar;
                       var QtdNotasProcessadas: Integer;
                       var TempoProcessamento: PChar;
                       var ValorTotalServicos: Double;
                       var ValotTotalDeducoes: Double ;
                       var Alertas: Integer;
                       var Erros: Integer ):Integer; external 'dms_nfse.dll';
function ConsultarNFSeLote( NrItem:Integer;
                           var InscricaoPrestador: PChar;
			                     var NumeroNFe: Integer ;
			                     var CodigoVerificacao:PChar ;
			                     var SerieRPS:PChar ;
			                     var NumeroRPS: Integer;
			                     var DataEmissaoRPS: PChar ;
			                     var RazaoSocialPrestador: PChar ;
                           var TipoRecolhimento: PChar ;
			                     var ValorDeduzir :Double;
			                     var ValorTotal : Double;
			                     var Aliquota : Double ):Integer; external 'dms_nfse.dll';

function ConsultarNotas(    CodCidade: Integer ;
                           CPFCNPJRemetente: PChar ;
                           InscricaoMunicipalPrestador: PChar ;
                           DataInicio: PChar;
                           DataTermino: PChar;
                       var QtdNotas : Integer ):Integer; external 'dms_nfse.dll';


function NotaConsultarNotas(  PosNotaConsulta : Integer ;
                             var NumeroNota : Integer ;
                             var DataProcessamento: PChar ;
                             var NumeroLote : Integer ;
                             var CodigoVerificacao : PChar ;
                             var Assinatura : PChar ;
                             var InscricaoMunicipalPrestador: PChar ;
                             var RazaoSocialPrestador: PChar ;
                             var TipoRPS: PChar ;
                             var SerieRPS : PChar ;
                             var NumeroRPS : Integer ;
                             var DataEmissaoRPS : PChar ;
                             var SituacaoRPS : PChar ;
                             var SerieRPSSubstituido :PChar ;
                             var NumeroRPSSubstituido : Integer ;
                             var NumeroNFSeSubstituida :Integer ;
                             var DataEmissaoNFSeSubstituida  : PChar ;
                             var SeriePrestacao :PChar ;
                             var InscricaoMunicipalTomador : PChar ;
                             var CPFCNPJTomador : PChar ;
                             var RazaoSocialTomador :PChar ;
                             var TipoLogradouroTomador :PChar ;
                             var LogradouroTomador :PChar;
                             var NumeroEnderecoTomador :PChar ;
                             var TipoBairroTomador: PChar ;
                             var BairroTomador: PChar ;
                             var CidadeTomador:PChar ;
                             var CidadeTomadorDescricao: PChar ;
                             var CEPTomador:PChar ;
                             var EmailTomador:PChar ;
                             var CodigoAtividade: PChar ;
                             var AliquotaAtividade: Double ;
                             var TipoRecolhimento :PChar ;
                             var MunicipioPrestacao: Integer ;
                             var MunicipioPrestacaoDescricao: PChar ;
                             var Operacao: PChar ;
                             var Tributacao: PChar ;
                             var ValorPIS : Double ;
                             var ValorCOFINS:Double ;
                             var ValorINSS : Double ;
                             var ValorIR : Double ;
                             var ValorCSLL : Double ;
                             var AliquotaPIS : Double ;
                             var AliquotaCOFINS : Double;
                             var AliquotaINSS : Double ;
                             var AliquotaIR : Double ;
                             var AliquotaCSLL : Double ;
                             var DescricaoRPS : PChar ;
                             var DDDPrestador  : PChar ;
                             var TelefonePrestador : PChar ;
                             var DDDTomador : PChar ;
                             var TelefoneTomador : PChar ;
                             var MotCancelamento : PChar ;
                             var Deducoes : Integer ;
                             var Itens : Integer ):Integer; external 'dms_nfse.dll';
function DecucaoNotaConsultarNotas( PosNotaConsulta: Integer ;
                                   PosDeducaoNotaConsulta: Integer ;
                                   var DeducaoPor :PChar ;
					                         var TipoDeducao: PChar ;
					                         var CPFCNPJReferencia: PChar ;
					                         var NumeroNFReferencia: Integer ;
					                         var ValorTotalReferencia : Double ;
					                         var PercentualDeduzir: Double ;
					                         var ValorDeduzir: Double): Integer; external 'dms_nfse.dll';

function ItemNotaConsultarNotas( PosNotaConsulta: Integer ;
                                PosItemNotaConsulta: Integer ;
                                var DiscriminacaoServico: PChar ;
					                      var Quantidade: Double ;
					                      var ValorUnitario: Double ;
                                var ValorTotal: Double): Integer; external 'dms_nfse.dll';

function ConsultarSeqRps( CodCidade: Integer ;
                          CPFCNPJRemetente: PChar ;
                          InscricaoMunicipalPrestador: PChar ;
                      var NroUltimoRps : Integer ):Integer; external 'dms_nfse.dll';


function ErroRetorno(CodErro: Integer ): PChar ; external 'dms_nfse.dll';

function ErroRetorno2(CodErro: Integer ): Integer ; external 'dms_nfse.dll';


{$R *.dfm}


procedure TForm1.BtnCriaRemessaClick(Sender: TObject);
var Erro: Integer ;
    //Parametros da 1 Etapa do Envio da Remessa

    CodCidade: Integer ;
		CPFCNPJRemetente: PChar;
    RazaoSocialRemetente: PChar;
		QtdRPS: Integer;
		ValorTotalServicos: Double;
		ValorTotalDeducoes: Double;

    //Parametros do 2 Etapa do Envio da Remessa

    InscricaoMunicipalPrestador: PChar ;
    RazaoSocialPrestador: PChar ;
    TipoRPS : PChar ;
    SerieRPS: PChar ;
    NumeroRPS : Integer ;
    DataEmissaoRPS : PChar ;
    SituacaoRPS : PChar ;
    SerieRPSSubstituido: PChar ;
    NumeroRPSSubstituido : Integer ;
    NumeroNFSeSubstituida : Integer ;
    DataEmissaoNFSeSubstituida : PChar ;
    SeriePrestacao: PChar ;
    InscricaoMunicipalTomador  : PChar ;
    CPFCNPJTomador  : PChar ;
    RazaoSocialTomador : PChar ;
    TipoLogradouroTomador : PChar ;
    LogradouroTomador : PChar ;
    NumeroEnderecoTomador : PChar ;
    TipoBairroTomador: PChar ;
    BairroTomador  : PChar ;
    CidadeTomador  : Integer ;
    CidadeTomadorDescricao: PChar ;
    CEPTomador : PChar ;
    EmailTomador  : PChar ;
    CodigoAtividade: PChar ;
    AliquotaAtividade : Double ;
    TipoRecolhimento  : PChar ;
    MunicipioPrestacao : Integer ;
    MunicipioPrestacaoDescricao: PChar ;
    Operacao   : PChar ;
    Tributacao : PChar ;
    ValorPIS    : Double ;
    ValorCOFINS : Double ;
    ValorINSS   : Double ;
    ValorIR     : Double ;
    ValorCSLL   : Double ;
    AliquotaPIS : Double ;
    AliquotaCOFINS : Double ;
    AliquotaINSS : Double ;
    AliquotaIR   : Double ;
    AliquotaCSLL : Double ;
    DescricaoRPS : PChar ;
    DDDPrestador : PChar ;
    TelefonePrestador : PChar ;
    DDDTomador        : PChar ;
    TelefoneTomador  : PChar ;
    MotCancelamento : PChar;
    //Quantidade de Servicos e Deducoes do RPS
    QtdServicos : Integer;
    QtdDeducoes : Integer;

    //Parametros do 3 Etapa : Itens do RPS
    DiscriminacaoServico: PChar ;
		Quantidade: Double ;
		ValorUnitario: Double ;
		ValorTotal: Double ;

    //Parametros da 3 Etapa : Deduoes da RPS
    DeducaoPor: PChar ;
		TipoDeducao: PChar ;
		CPFCNPJReferencia: PChar ;
		NumeroNFReferencia: Integer ;
		ValorTotalReferencia: Double ;
		PercentualDeduzir: Double ;
		ValorDeduzir: Double ;

    i, j: Integer ;


    Assincrono: PChar;
    Sucesso: PChar ;
    NumeroLote: Integer ;

    DataEnvioLote: PChar ;
    QtdNotasProcessadas : Integer ;

    Erros, Alertas : Integer ;


    //Parametros do Erro de Retorno
    CodErro: Integer;
    Descricao: PChar;
    InscricaoPrestador : PChar;

    //RPS do Retorno
    NumeroNFe: Integer ;
    CodigoVerificacao: PChar ;

    DocAssinatura: PChar ;


begin
  //Aponta a URL de acesso ao WebService
  setURL( 'http://200.201.194.78/WsNFe2/LoteRps.jws', 'http://200.201.194.78/WsNFe2/LoteRps.jws?wsdl');

  //A chamada da funo abaixo  opcional, no  necessario fazer chamada a ela , mais se quizer a dll ir gravar os arquivos xml gerados na pasta configurada abaixo,
  //Se no for feita nenhuma chamada a esta funo a dll no ir gravar os arquivos xml
  if ( setGravaArquivoXML( 'c:\tmp\' ) = 0 ) then
    showmessage('Os arquivos XML gerados sero gravados em c:\tmp');

  // 1 ETAPA - CRIA O LOTE DE REMESSA

  CodCidade            := 1219 ;
	CPFCNPJRemetente     := '04569071000403' ;
  RazaoSocialRemetente := 'EMPRESA MODELO';

  Erro:= CriarRemessa( CodCidade, CPFCNPJRemetente, RazaoSocialRemetente );

  if ( Erro <> 0 ) then  begin
    ShowMessage('Descrio do erro ocorrido na criao do lote de remessa : ' + ErroRetorno( Erro ));
    Abort;
  end ;


  // 2 ETAPA -  REGISTRO DOS RPS
  //Aqui pode ser iniciado um loop para cada RPS a ser enviada no lote
  QtdRPS := 1; //Quantidade de RPS a ser criado
  for i := 1 to QtdRPS do begin
    InscricaoMunicipalPrestador := '0871834' ;
    RazaoSocialPrestador := 'EMPRESA DE TESTES';
    TipoRPS   := 'RPS';
    SerieRPS  := 'NF';
    NumeroRPS := 23 + i; //Numero Sequencial de Rps - Para buscar o numero do ultimo RPS convertido usar a funo Consulta Sequencial RPS
    DataEmissaoRPS := '26/08/2009 15:30:00';
    SituacaoRPS := 'N';
    SerieRPSSubstituido := '';
    NumeroRPSSubstituido := 0;
    NumeroNFSeSubstituida := 0;
    DataEmissaoNFSeSubstituida := '01/01/1900';
    SeriePrestacao := '99';
    InscricaoMunicipalTomador := '0000000';
    CPFCNPJTomador := '00000000191';
    RazaoSocialTomador := 'EMPRESA DE TESTES';
    TipoLogradouroTomador := '';
    LogradouroTomador := 'RUA SETE DE SETEMBRO';
    NumeroEnderecoTomador := '';
    TipoBairroTomador := 'Bairro';
    BairroTomador := 'CENTRO';
    CidadeTomador := 0001219;
    CidadeTomadorDescricao := 'TERESINA';
    CEPTomador := '64001210';
    EmailTomador := 'res@bol.com.br';
    CodigoAtividade := '431340000';
    AliquotaAtividade := 5.00;
    TipoRecolhimento := 'A';
    MunicipioPrestacao :=  1219;
    MunicipioPrestacaoDescricao := 'TERESINA';
    Operacao := 'A';
    Tributacao  :=  'T';
    ValorPIS := 0;
    ValorCOFINS :=  0;
    ValorINSS := 0;
    ValorIR := 0;
    ValorCSLL := 0;
    AliquotaPIS := 0;
    AliquotaCOFINS  :=  0;
    AliquotaINSS := 0;
    AliquotaIR := 0;
    AliquotaCSLL := 0;
    DescricaoRPS := 'SERVICOS DE LIMPEZA E CONSERVACAO COM FORNECIMENTO DE MATERIAL PARA O CONTRATANTE EM TERESINA/PI, CONFORME CONTRATO FIRMADO EM 03.11.2004 E TERMO ADITIVO.';
    DDDPrestador :=  '11';
    TelefonePrestador :=  '99999999';
    DDDTomador := '11';
    TelefoneTomador := '99999999' ;
    MotCancelamento := '';

    //Nmero de servios e deducoes do RPS
    QtdServicos := 1 ;
    QtdDeducoes := 1 ;

    Erro := RPSRemessa( InscricaoMunicipalPrestador, RazaoSocialPrestador, TipoRPS, SerieRPS,
                        NumeroRPS, DataEmissaoRPS, SituacaoRPS, SerieRPSSubstituido,
                        NumeroRPSSubstituido, NumeroNFSeSubstituida, DataEmissaoNFSeSubstituida ,
                        SeriePrestacao, InscricaoMunicipalTomador, CPFCNPJTomador  ,
                        RazaoSocialTomador, TipoLogradouroTomador, LogradouroTomador ,
                        NumeroEnderecoTomador, TipoBairroTomador, BairroTomador  ,
                        CidadeTomador, CidadeTomadorDescricao, CEPTomador ,
                        EmailTomador, CodigoAtividade, AliquotaAtividade, TipoRecolhimento  ,
                        MunicipioPrestacao, MunicipioPrestacaoDescricao, Operacao   ,
                        Tributacao, ValorPIS, ValorCOFINS, ValorINSS,
                        ValorIR, ValorCSLL, AliquotaPIS, AliquotaCOFINS,
                        AliquotaINSS, AliquotaIR, AliquotaCSLL, DescricaoRPS,
                        DDDPrestador, TelefonePrestador, DDDTomador, TelefoneTomador, MotCancelamento ) ;

    if Erro <> 0 then begin
      ShowMessage( 'Erro no RPS. Descrio do Erro ' +  ErroRetorno( Erro ));
      break ; //Interompe processo
    end ;

    //3 ETAPA, adicionar os servicos da RPS,  necessrio chamar a funo do registro para cada servico da rps.
    for j:= 1 to QtdServicos do begin
      DiscriminacaoServico :=  'Servio ...' ;
      Quantidade := 1 ;
		  ValorUnitario := 12000.12;
		  ValorTotal :=  12000.12 ;

      Erro:= RPSItem( DiscriminacaoServico, Quantidade, ValorUnitario, ValorTotal) ;

      if ( Erro <> 0) then begin
        ShowMessage( 'Erro na item da RPS, Descrio do Erro : ' +  ErroRetorno( Erro ));
        Break ; //Interrompe aplicacao
      end ;
    end ;
    //FIM DA 3 ETAPA

    //4 ETAPA - adicionar dedues da remessa, caso tenha deduoes
    if ( QtdDeducoes > 0 ) then
      for j := 1 to QtdDeducoes do begin
        DeducaoPor  := 'Valor' ;
		    TipoDeducao := 'Despesas com Materiais';
		    CPFCNPJReferencia    := '66442677000198';
		    NumeroNFReferencia   := 48;
		    ValorTotalReferencia := 100;
		    PercentualDeduzir    := 0;
		    ValorDeduzir         := 5.0;

        Erro := RPSDeducao( DeducaoPor, TipoDeducao, CPFCNPJReferencia, NumeroNFReferencia,
					                  ValorTotalReferencia, PercentualDeduzir, ValorDeduzir  ) ;

        if ( Erro <> 0 ) then begin
          ShowMessage( 'Erro na deduo da RPS, Descrio do Erro : ' +  ErroRetorno( Erro ));
          Break; //Interrompe aplicao
        end ;
      end ;
    //FIM DA 4 ETAPA
    //FIM DA 2 ETAPA
  End; //aqui pode ser finalizado o loop que rota todas as RPS a serem enviadas
  //FIM DA 1 ETAPA

  //5 ETAPA - FECHA LOTE E ENVIA DECLARAO, NESTA ETAPA IRA RETORNAR TRUE PARA SUCESSO, CASO O RETONO TENHA SIDO ASSINCRONO ELE RETORNA FALSO
  //E O NUMERO DE LOTE GERADO COM OS DEMAIS DADOS

  Assincrono := 'S' ; //Coloque S para envio assincrono e N para envio sincrono
  DocAssinatura := ''; //SO COLOCAR SE TIVER UM CERTIFICADO DIGITAL INSTALADO SE NAO PREENCHE COM VAZIO
  Erro := EnviarDeclaracao( DocAssinatura, Assincrono, Sucesso, NumeroLote, QtdNotasProcessadas,
                            ValorTotalServicos, ValorTotalDeducoes, Erros, Alertas );

  if Erro <> 0 then begin
    ShowMessage( 'Erro ao Enviar Declarao.  Descrio : '  + ErroRetorno( Erro ) ) ;
    Abort;
  end ;

  ShowMessage('Lote Gerado : ' + IntToStr( NumeroLote ) + '  Notas Processadas : '  +  IntToStr( QtdNotasProcessadas ) + ' Erros : ' + IntToStr(Erros));
  //6 ETAPA - PEGA ERROS E ALERTAS DO PROCESSAMENTO
  if Erros > 0 then begin
     for j := 0 to Erros - 1 do begin
     Erro := ErrosRetorno( J, CodErro, Descricao, InscricaoPrestador, SerieRPS,
                           NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
     if Erro = 0  then
       ShowMessage('Erro : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
     end ;
  end;

   if Alertas > 0 then begin
     for j := 0 to Alertas - 1 do begin
     Erro := AlertasRetorno( J, CodErro, Descricao, InscricaoPrestador,
                             SerieRPS, NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
     if Erro = 0  then
       ShowMessage('Alerta : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
     end ;
  end;
  //7 ETAPA PEGA OS DADOS DAS NOTAS PROCESSADAS.
  //OBS: CASO O RETONO SEJA ASSINCRONO SERA RETORNADO A QUANTIDADE DE NOTAS PROCESSADAS IGUAL A ZERO, E SE DEVE USAR O CONSULTA LOTE PARA VERIFICAR O PROCESSAMENTO.
  if QtdNotasProcessadas > 0 then
    for j  := 0 to QtdNotasProcessadas - 1 do begin
    Erro :=  NfseRetorno( j, InscricaoPrestador, NumeroNFe, CodigoVerificacao,
                         RazaoSocialPrestador, SerieRPS ,NumeroRPS, DataEmissaoRPS );
    if Erro <> 0 then
      ShowMessage('Erro ao consultar RPS ' + ErroRetorno( Erro ))
      else begin
      ShowMessage('RPS ' + IntToStr( NumeroRps) + ' NFSe: ' + IntToStr(NumeroNFe) + ' gerada.')
    end ;
    end;

end;

procedure TForm1.BtnConsultaLoteClick(Sender: TObject);
var CodCidade: Integer ;
    CPFCNPJRemetente: PChar ;
    NumeroLote: Integer ;
    Sucesso: PChar;
    DataEnvioLote: PChar;
    QtdNotasProcessadas: Integer;
    TempoProcessamento: PChar;
    ValorTotalServicos: Double;
    ValotTotalDeducoes: Double ;
    Alertas: Integer;
    Erros: Integer;


    i: integer ;

    //Variaveis das notas do lote
    InscricaoPrestador: PChar;
		NumeroNFe: Integer ;
		CodigoVerificacao:PChar ;
		SerieRPS:PChar ;
		NumeroRPS: Integer;
		DataEmissaoRPS: PChar ;
		RazaoSocialPrestador: PChar ;
    TipoRecolhimento: PChar ;
		ValorDeduzir :Double;
		ValorTotal : Double;
		Aliquota : Double ;

    Erro : Integer ;
    j: Integer;
     //Parametros do Erro de Retorno
    CodErro: Integer;
    Descricao: PChar;


begin
   //Aponta a URL de acesso ao WebService
  setURL( 'http://200.201.194.78/WsNFe2/LoteRps.jws', 'http://200.201.194.78/WsNFe2/LoteRps.jws?wsdl');

  CodCidade := 1219 ;  //Codigo da cidade
  CPFCNPJRemetente := '04569071000403' ;
  NumeroLote := 8831; //Numero do lote a ser consultado

  Erro := ConsultarLote( CodCidade, CPFCNPJRemetente,  NumeroLote, Sucesso,
                         DataEnvioLote, QtdNotasProcessadas, TempoProcessamento, ValorTotalServicos,
                         ValotTotalDeducoes, Alertas, Erros ) ;
  if ( Erro <> 0 ) then begin
    ShowMessage('Erro ao consultar lote. Descrio :' + ErroRetorno( Erro ));
    Abort;
  end ;

  ShowMessage(' Lote : ' + IntToStr( NumeroLote ) + ' - Qtd. Notas Processadas : ' + IntToStr( QtdNotasProcessadas ) + ' Erros : ' + IntToStr( Erros ) + ' cpf=' + CPFCNPJRemetente);

  if Erros > 0 then begin
     for j := 0 to Erros - 1 do begin

     Erro := ErrosRetorno( J, CodErro, Descricao, InscricaoPrestador, SerieRPS,
                           NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
     if Erro = 0  then
       ShowMessage('Erro : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
     end ;
  end;

  if Alertas > 0 then begin
   for j := 0 to Alertas - 1 do begin

   Erro := AlertasRetorno( J, CodErro, Descricao, InscricaoPrestador, SerieRPS,
                             NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
   if Erro = 0  then
     ShowMessage('Alerta : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
   end ;
  end;

  i := 0 ;
  while ( i  <  QtdNotasProcessadas ) do begin

  Erro := ConsultarNFSeLote( i, InscricaoPrestador, NumeroNFe, CodigoVerificacao, SerieRPS,
			                       NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador, TipoRecolhimento,
			                       ValorDeduzir, ValorTotal , Aliquota ) ;

  if  (Erro <> 0 )then begin
    ShowMessage('Erro ao carregar dados da nota : ' + ErroRetorno( Erro ));
    Abort;
  end;
    ShowMessage( 'Numero Nota : ' + IntToStr( NumeroNFe ) + ' - Numero RPS : ' + IntToStr( NumeroRPS) + ' - Erros no Processamento:' + IntToStr( Erros ) + ' Alertas : ' + IntToStr( Alertas ) + ' Prestador : ' + RazaoSocialPrestador  );
  i := i + 1 ;
  end;

end;

procedure TForm1.BtnConsultaNotaClick(Sender: TObject);
var CodCidade: Integer ;
    CPFCNPJRemetente: PChar ;
    InscricaoMunicipalPrestador: PChar ;
    DataInicio: PChar;
    DataTermino: PChar;
    QtdNotas : Integer ;

    PosNotaConsulta, PosDeducaoNotaConsulta, PosItemNotaConsulta: Integer ;

    //Variaveis dos itens da nota
    NumeroNota : Integer ;
    DataProcessamento: PChar ;
    NumeroLote : Integer ;
    CodigoVerificacao : PChar ;
    Assinatura : PChar ;
    RazaoSocialPrestador: PChar ;
    TipoRPS: PChar ;
    SerieRPS : PChar ;
    NumeroRPS : Integer ;
    DataEmissaoRPS : PChar ;
    SituacaoRPS : PChar ;
    SerieRPSSubstituido :PChar ;
    NumeroRPSSubstituido : Integer ;
    NumeroNFSeSubstituida :Integer ;
    DataEmissaoNFSeSubstituida  : PChar ;
    SeriePrestacao :PChar ;
    InscricaoMunicipalTomador : PChar ;
    CPFCNPJTomador : PChar ;
    RazaoSocialTomador :PChar ;
    TipoLogradouroTomador :PChar ;
    LogradouroTomador :PChar;
    NumeroEnderecoTomador :PChar ;
    TipoBairroTomador: PChar ;
    BairroTomador: PChar ;
    CidadeTomador:PChar ;
    CidadeTomadorDescricao: PChar ;
    CEPTomador:PChar ;
    EmailTomador:PChar ;
    CodigoAtividade: PChar ;
    AliquotaAtividade: Double ;
    TipoRecolhimento :PChar ;
    MunicipioPrestacao: Integer ;
    MunicipioPrestacaoDescricao: PChar ;
    Operacao: PChar ;
    Tributacao: PChar ;
    ValorPIS : Double ;
    ValorCOFINS:Double ;
    ValorINSS : Double ;
    ValorIR : Double ;
    ValorCSLL : Double ;
    AliquotaPIS : Double ;
    AliquotaCOFINS : Double;
    AliquotaINSS : Double ;
    AliquotaIR : Double ;
    AliquotaCSLL : Double ;
    DescricaoRPS : PChar ;
    DDDPrestador  : PChar ;
    TelefonePrestador : PChar ;
    DDDTomador : PChar ;
    TelefoneTomador : PChar ;
    MotCancelamento : PChar ;
    Deducoes : Integer ;
    Itens : Integer ;

    //Variaveis das dedues da nota

    DeducaoPor :PChar ;
		TipoDeducao: PChar ;
		CPFCNPJReferencia: PChar ;
		NumeroNFReferencia: Integer ;
		ValorTotalReferencia : Double ;
		PercentualDeduzir: Double ;
		ValorDeduzir: Double ;

    //Variaveis dos itens da nota
    DiscriminacaoServico: PChar ;
		Quantidade: Double ;
		ValorUnitario: Double ;
    ValorTotal: Double  ;

    Erro : Integer ;


begin
    setURL( 'http://200.201.194.78/WsNFe2/LoteRps.jws', 'http://200.201.194.78/WsNFe2/LoteRps.jws?wsdl');

  CodCidade                   := 1219 ;
  CPFCNPJRemetente            := '04569071000403';
  InscricaoMunicipalPrestador := '0871834';
  DataInicio                  := '01/12/2008' ;
  DataTermino                 := '30/12/2009';

  Erro := ConsultarNotas( CodCidade, CPFCNPJRemetente, InscricaoMunicipalPrestador,DataInicio,
                          DataTermino, QtdNotas ) ;

  if ( Erro <> 0 )then  begin
    ShowMessage('Erro ao consultar notas : ' + ErroRetorno(Erro));
    Abort;
  end;

  ShowMessage( 'Foram recebidas ' + IntToStr( QtdNotas ) + ' notas na Consulta');
  for PosNotaConsulta := 0 to QtdNotas - 1 do begin
    Erro := NotaConsultarNotas( PosNotaConsulta , NumeroNota , DataProcessamento, NumeroLote ,
                                CodigoVerificacao , Assinatura , InscricaoMunicipalPrestador,
                                RazaoSocialPrestador, TipoRPS, SerieRPS , NumeroRPS , DataEmissaoRPS ,
                                SituacaoRPS , SerieRPSSubstituido ,NumeroRPSSubstituido ,NumeroNFSeSubstituida ,
                                DataEmissaoNFSeSubstituida  , SeriePrestacao ,InscricaoMunicipalTomador ,
                                CPFCNPJTomador , RazaoSocialTomador ,TipoLogradouroTomador , LogradouroTomador ,
                                NumeroEnderecoTomador , TipoBairroTomador, BairroTomador, CidadeTomador,
                                CidadeTomadorDescricao, CEPTomador, EmailTomador, CodigoAtividade,
                                AliquotaAtividade, TipoRecolhimento ,MunicipioPrestacao,
                                MunicipioPrestacaoDescricao, Operacao, Tributacao,
                                ValorPIS , ValorCOFINS, ValorINSS , ValorIR ,
                                ValorCSLL , AliquotaPIS , AliquotaCOFINS , AliquotaINSS ,
                                AliquotaIR , AliquotaCSLL , DescricaoRPS , DDDPrestador  ,
                                TelefonePrestador , DDDTomador , TelefoneTomador , MotCancelamento,
                                Deducoes , Itens  ) ;
     if ( Erro <> 0 ) then  begin
       ShowMessage('Erro ao buscar dados da nota: ' + ErroRetorno(Erro));
     end else begin
       ShowMessage( 'NFSe :' + IntToStr( NumeroNota ) + ' - RPS : ' + IntToStr( NumeroRPS ) + ' Quant. Itens : ' + IntToStr( Itens ) ) ;

       for PosDeducaoNotaConsulta := 0 to Deducoes - 1 do begin
         Erro := DecucaoNotaConsultarNotas( PosNotaConsulta, PosDeducaoNotaConsulta, DeducaoPor,
					                                  TipoDeducao, CPFCNPJReferencia, NumeroNFReferencia,
					                                  ValorTotalReferencia, PercentualDeduzir, ValorDeduzir ) ;
       if Erro <> 0 then
         ShowMessage( 'Deducao ' + TipoDeducao + ' Valor : ' + CurrToStr( ValorDeduzir ) ) ;
       end ;

       for PosItemNotaConsulta := 0 to Itens - 1 do begin
         Erro := ItemNotaConsultarNotas( PosNotaConsulta, PosItemNotaConsulta, DiscriminacaoServico,
					                               Quantidade, ValorUnitario, ValorTotal );
         if Erro = 0 then
           ShowMessage( 'Item: ' + DiscriminacaoServico + ' Quantidade : ' + CurrToStr( Quantidade ) + ' Vl. Total : ' + CurrToStr( ValorTotal ) ) ;
       end ;

     end;


  end;



end;







procedure TForm1.BtnConSeqRPSClick(Sender: TObject);
var CodCidade: Integer ;
    CPFCNPJRemetente: PChar ;
    InscricaoMunicipalPrestador: PChar ;
    NroUltimoRpsConvertido : Integer ;
    Erro : Integer;
begin

    setURL( 'http://200.201.194.78/WsNFe2/LoteRps.jws', 'http://200.201.194.78/WsNFe2/LoteRps.jws?wsdl');
    
  CodCidade                   := 1219 ;
  CPFCNPJRemetente            := '04569071000403';
  InscricaoMunicipalPrestador := '0871834';


  Erro := ConsultarSeqRps( CodCidade, CPFCNPJRemetente, InscricaoMunicipalPrestador, NroUltimoRpsConvertido ) ;
  if (Erro = 0) then
   begin
     ShowMessage('Nmero do ltimo RPS convertido:' + IntToStr(NroUltimoRpsConvertido));
   end;
end;

end.
