unit UntConsultaLote;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFrmConsultaLote = class(TForm)
    EdtNroLote: TEdit;
    LblNroLote: TLabel;
    BtnConsulta: TButton;
    procedure BtnConsultaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  //Chamada da funo de consulta lote da dll
  function ConsultarLote(    CodCidade: Integer ;
                           CPFCNPJRemetente: PChar ;
                           NumeroLote: Integer ;
                       var Sucesso: PChar;
                       var DataEnvioLote: PChar;
                       var QtdNotasProcessadas: Integer;
                       var TempoProcessamento: PChar;
                       var ValorTotalServicos: Double;
                       var ValotTotalDeducoes: Double ;
                       var Alertas: Integer;
                       var Erros: Integer):Integer; stdcall;
  //Chamada da funo que busca as Notas de Cada Lote consultado na funo anterior
  function ConsultarNFSeLote( NrItem:Integer;
                           var InscricaoPrestador: PChar;
			                     var NumeroNFe: Integer ;
			                     var CodigoVerificacao:PChar ;
			                     var SerieRPS:PChar ;
			                     var NumeroRPS: Integer;
			                     var DataEmissaoRPS: PChar ;
			                     var RazaoSocialPrestador: PChar ;
                           var TipoRecolhimento: PChar ;
			                     var ValorDeduzir :Double;
			                     var ValorTotal : Double;
			                     var Aliquota : Double ):Integer; stdcall;
  //Caso tenha algum Erro de retorno no envio da declarao ou na consulta de lote  pega os dados do erro.
function ErrosRetorno( ErroItem:Integer;
                       var Codigo: Integer;
                       var Descricao: PChar;
                       var InscricaoPrestador : PChar;
                       var SerieRPS: PChar ;
                       var NumeroRPS: Integer;
                       var DataEmissaoRPS:PChar;
                       var RazaoSocialPrestador: PChar ):Integer; stdcall ;

//Caso tenha algum Alerta de retorno no envio da declarao ou na consulta de lote  pega os dados do erro.
function AlertasRetorno( ErroItem:Integer;
                       var Codigo: Integer;
                       var Descricao: PChar;
                       var InscricaoPrestador : PChar;
                       var SerieRPS: PChar ;
                       var NumeroRPS: Integer;
                       var DataEmissaoRPS:PChar;
                       var RazaoSocialPrestador: PChar ):Integer; stdcall ;




var
  FrmConsultaLote: TFrmConsultaLote;

implementation

uses  UntTelaPrincipal;


{$R *.dfm}
//CHAMADAS EXTERNAS DAS FUNES
function ConsultarLote(     CodCidade: Integer ;
                           CPFCNPJRemetente: PChar ;
                           NumeroLote: Integer ;
                       var Sucesso: PChar;
                       var DataEnvioLote: PChar;
                       var QtdNotasProcessadas: Integer;
                       var TempoProcessamento: PChar;
                       var ValorTotalServicos: Double;
                       var ValotTotalDeducoes: Double ;
                       var Alertas: Integer;
                       var Erros: Integer ):Integer; external 'dms_nfse.dll';


function ConsultarNFSeLote( NrItem:Integer;
                           var InscricaoPrestador: PChar;
			                     var NumeroNFe: Integer ;
			                     var CodigoVerificacao:PChar ;
			                     var SerieRPS:PChar ;
			                     var NumeroRPS: Integer;
			                     var DataEmissaoRPS: PChar ;
			                     var RazaoSocialPrestador: PChar ;
                           var TipoRecolhimento: PChar ;
			                     var ValorDeduzir :Double;
			                     var ValorTotal : Double;
			                     var Aliquota : Double ):Integer; external 'dms_nfse.dll';
function ErrosRetorno( ErroItem:Integer;
                         var Codigo: Integer;
                         var Descricao: PChar;
                         var InscricaoPrestador : PChar;
                         var SerieRPS: PChar ;
                         var NumeroRPS: Integer;
                         var DataEmissaoRPS:PChar;
                         var RazaoSocialPrestador: PChar ):Integer; external 'dms_nfse.dll';

function AlertasRetorno( ErroItem:Integer;
                         var Codigo: Integer;
                         var Descricao: PChar;
                         var InscricaoPrestador : PChar;
                         var SerieRPS: PChar ;
                         var NumeroRPS: Integer;
                         var DataEmissaoRPS:PChar;
                         var RazaoSocialPrestador: PChar ):Integer; external 'dms_nfse.dll';

procedure TFrmConsultaLote.BtnConsultaClick(Sender: TObject);
var CodCidade: Integer ;
    CPFCNPJRemetente: PChar ;
    NumeroLote: Integer ;
    Sucesso: PChar;
    DataEnvioLote: PChar;
    QtdNotasProcessadas: Integer;
    TempoProcessamento: PChar;
    ValorTotalServicos: Double;
    ValotTotalDeducoes: Double ;
    Alertas: Integer;
    Erros: Integer;


    i: integer ;

    //Variaveis das notas do lote
    InscricaoPrestador: PChar;
		NumeroNFe: Integer ;
		CodigoVerificacao:PChar ;
		SerieRPS:PChar ;
		NumeroRPS: Integer;
		DataEmissaoRPS: PChar ;
		RazaoSocialPrestador: PChar ;
    TipoRecolhimento: PChar ;
		ValorDeduzir :Double;
		ValorTotal : Double;
		Aliquota : Double ;

    Erro : Integer ;
    j: Integer;
     //Parametros do Erro de Retorno
    CodErro: Integer;
    Descricao: PChar;


begin

  CodCidade := frmprincipal.CodCid ;  //Codigo da cidade
  CPFCNPJRemetente := Pchar(frmprincipal.CpfCnpjRemetente) ;
  NumeroLote := StrToInt(EdtNroLote.Text); //Numero do lote a ser consultado

  Erro := ConsultarLote( CodCidade, CPFCNPJRemetente,  NumeroLote, Sucesso,
                         DataEnvioLote, QtdNotasProcessadas, TempoProcessamento, ValorTotalServicos,
                         ValotTotalDeducoes, Alertas, Erros ) ;
  if ( Erro <> 0 ) then begin
    ShowMessage('Erro ao consultar lote. Descrio :' + ErroRetorno( Erro ));
    Abort;
  end ;

  ShowMessage(' Lote : ' + IntToStr( NumeroLote ) + ' Sucesso = ' + Sucesso + ' - Qtd. Notas Processadas : ' + IntToStr( QtdNotasProcessadas ) + ' Erros : ' + IntToStr( Erros ) );

  if Erros > 0 then begin
     for j := 0 to Erros - 1 do begin

     Erro := ErrosRetorno( J, CodErro, Descricao, InscricaoPrestador, SerieRPS,
                           NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
     if Erro = 0  then
       ShowMessage('Erro : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
     end ;
  end;

  if Alertas > 0 then begin
   for j := 0 to Alertas - 1 do begin

   Erro := AlertasRetorno( J, CodErro, Descricao, InscricaoPrestador, SerieRPS,
                             NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
   if Erro = 0  then
     ShowMessage('Alerta : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
   end ;
  end;

  i := 0 ;

  while ( i  <  QtdNotasProcessadas ) do begin

  Erro := ConsultarNFSeLote( i, InscricaoPrestador, NumeroNFe, CodigoVerificacao, SerieRPS,
			                       NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador, TipoRecolhimento,
			                       ValorDeduzir, ValorTotal , Aliquota ) ;

  if  (Erro <> 0 )then begin
    ShowMessage('Erro ao carregar dados da nota : ' + ErroRetorno( Erro ));
    Abort;
  end;
    ShowMessage( 'Numero Nota : ' + IntToStr( NumeroNFe ) + ' - Numero RPS : ' + IntToStr( NumeroRPS) + '  Prestador : ' + RazaoSocialPrestador  );
  i := i + 1 ;
  end;


end;

end.
