unit UntConverterRpsConversao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, StdCtrls, CheckLst;

type
  TfrmConversao = class(TForm)
    QryAux: TADOQuery;
    LstMes: TCheckListBox;
    BtnOk: TButton;
    chkassina: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  //Procedure usada para passar a URL do WebService
procedure setURL( varsRPS_HTTPSURL :PChar; varsRPS_HTTPSWSDL: PChar ); stdcall ;

//Funo para setar o caminho do arquivo XML temporario criado. Caso queira grara arquivos XML de remessa antes de enviar. caso no queira gravar, no  necessrio fazer chamada a essa funo
function setGravaArquivoXML( Caminho: PChar ):Integer ; stdcall ;


//OBS: Todas as funes listas abaixo retornam ZERO caso nao tenha ocorrido erro , e caso tenha ocorrido algum erro retorna o cdigo do erro.

//Funo para criar o lote de remessa, em cada novo lote, em cada nova remessa  necessrio chamar essa funo para criar o lote.
function CriarRemessa( CodCidade: Integer ;
                       CPFCNPJRemetente: PChar;
                       RazaoSocialRemetente: PChar): Integer ; stdcall ;

//Funao para informar os dados de cada RPS
function RPSRemessa( InscricaoMunicipalPrestador: PChar ;
                     RazaoSocialPrestador: PChar ;
                     TipoRPS : PChar ;
                     SerieRPS: PChar ;
                     NumeroRPS : Integer ;
                     DataEmissaoRPS : PChar ;
                     SituacaoRPS : PChar ;
                     SerieRPSSubstituido: PChar ;
                     NumeroRPSSubstituido : Integer ;
                     NumeroNFSeSubstituida : Integer ;
                     DataEmissaoNFSeSubstituida : PChar ;
                     SeriePrestacao: PChar ;
                     InscricaoMunicipalTomador  : PChar ;
                     CPFCNPJTomador  : PChar ;
                     RazaoSocialTomador : PChar ;
                     TipoLogradouroTomador : PChar ;
                     LogradouroTomador : PChar ;
                     NumeroEnderecoTomador : PChar ;
                     TipoBairroTomador: PChar ;
                     BairroTomador  : PChar ;
                     CidadeTomador  : Integer ;
                     CidadeTomadorDescricao: PChar ;
                     CEPTomador : PChar ;
                     EmailTomador  : PChar ;
                     CodigoAtividade: PChar ;
                     AliquotaAtividade : Double ;
                     TipoRecolhimento  : PChar ;
                     MunicipioPrestacao : Integer ;
                     MunicipioPrestacaoDescricao: PChar ;
                     Operacao   : PChar ;
                     Tributacao : PChar ;
                     ValorPIS    : Double ;
                     ValorCOFINS : Double ;
                     ValorINSS   : Double ;
                     ValorIR     : Double ;
                     ValorCSLL   : Double ;
                     AliquotaPIS : Double ;
                     AliquotaCOFINS : Double ;
                     AliquotaINSS : Double ;
                     AliquotaIR   : Double ;
                     AliquotaCSLL : Double ;
                     DescricaoRPS : PChar ;
                     DDDPrestador : PChar ;
                     TelefonePrestador : PChar ;
                     DDDTomador        : PChar ;
                     TelefoneTomador  : PChar ;
                     MotCancelamento : PChar) : Integer ; stdcall ;
//Funo para passar os dados de cada item do RPS
function RPSItem( DiscriminacaoServico: PChar ;
					        Quantidade: Double ;
					        ValorUnitario: Double ;
					        ValorTotal: Double  ): Integer ; stdcall ;

//Funo para passar os dado das dedues do RPS
function RPSDeducao( DeducaoPor: PChar ;
					           TipoDeducao: PChar ;
					           CPFCNPJReferencia: PChar ;
					           NumeroNFReferencia: Integer ;
					           ValorTotalReferencia: Double ;
					           PercentualDeduzir: Double ;
					           ValorDeduzir: Double  ): Integer ; stdcall ;

//Funo para finalizar lote e enviar declarao
function EnviarDeclaracao(    DocAssinatura : PChar ;
                          var Assincrono: PChar;
                          var Sucesso : PChar ;
		                      var NumeroLote: Integer ;
                          var QtdNotasProcessadas : Integer ;
                          var ValorTotalServicos: Double ;
                          var ValorTotalDeducoes:Double;
                          var Erros: Integer;
                          var Alertas: Integer): Integer ; stdcall ;

//Caso tenha algum Erro de retorno no envio da declarao ou na consulta de lote  pega os dados do erro.
function ErrosRetorno( ErroItem:Integer;
                       var Codigo: Integer;
                       var Descricao: PChar;
                       var InscricaoPrestador : PChar;
                       var SerieRPS: PChar ;
                       var NumeroRPS: Integer;
                       var DataEmissaoRPS:PChar;
                       var RazaoSocialPrestador: PChar ):Integer; stdcall ;

//Caso tenha algum Alerta de retorno no envio da declarao ou na consulta de lote  pega os dados do erro.
function AlertasRetorno( ErroItem:Integer;
                       var Codigo: Integer;
                       var Descricao: PChar;
                       var InscricaoPrestador : PChar;
                       var SerieRPS: PChar ;
                       var NumeroRPS: Integer;
                       var DataEmissaoRPS:PChar;
                       var RazaoSocialPrestador: PChar ):Integer; stdcall ;
//Se o servico for sincrono no envio da declarao ele retorna a quantidade de notas processadas,
//Pode-se usar esta funo para pegar os PPS do retorno.
function NfseRetorno( RetornoItem : Integer ;
                     var InscricaoPrestador: PChar ;
                     var NumeroNFe: Integer ;
                     var CodigoVerificacao: PChar ;
                     var RazaoSocialPrestador: PChar ;
                     var SerieRPS : PChar ;
				             var NumeroRPS: Integer ;
				             var DataEmissaoRPS : PChar ) :Integer ; stdcall;


var
  frmConversao: TfrmConversao;

implementation

uses UntTelaPrincipal, UntConverterRps ;

{$R *.dfm}

procedure setURL( varsRPS_HTTPSURL :PChar; varsRPS_HTTPSWSDL: PChar ); external 'dms_nfse.dll';


function setGravaArquivoXML( Caminho: PChar ):Integer ; external 'dms_nfse.dll';

function CriarRemessa( CodCidade: Integer ;
		                   CPFCNPJRemetente: PChar;
                       RazaoSocialRemetente: PChar ): Integer ; external 'dms_nfse.dll';


function RPSRemessa( InscricaoMunicipalPrestador: PChar ;
                     RazaoSocialPrestador: PChar ;
                     TipoRPS : PChar ;
                     SerieRPS: PChar ;
                     NumeroRPS : Integer ;
                     DataEmissaoRPS : PChar ;
                     SituacaoRPS : PChar ;
                     SerieRPSSubstituido: PChar ;
                     NumeroRPSSubstituido : Integer ;
                     NumeroNFSeSubstituida : Integer ;
                     DataEmissaoNFSeSubstituida : PChar ;
                     SeriePrestacao: PChar ;
                     InscricaoMunicipalTomador  : PChar ;
                     CPFCNPJTomador  : PChar ;
                     RazaoSocialTomador : PChar ;
                     TipoLogradouroTomador : PChar ;
                     LogradouroTomador : PChar ;
                     NumeroEnderecoTomador : PChar ;
                     TipoBairroTomador: PChar ;
                     BairroTomador  : PChar ;
                     CidadeTomador  : Integer ;
                     CidadeTomadorDescricao: PChar ;
                     CEPTomador : PChar ;
                     EmailTomador  : PChar ;
                     CodigoAtividade: PChar ;
                     AliquotaAtividade : Double ;
                     TipoRecolhimento  : PChar ;
                     MunicipioPrestacao : Integer ;
                     MunicipioPrestacaoDescricao: PChar ;
                     Operacao   : PChar ;
                     Tributacao : PChar ;
                     ValorPIS    : Double ;
                     ValorCOFINS : Double ;
                     ValorINSS   : Double ;
                     ValorIR     : Double ;
                     ValorCSLL   : Double ;
                     AliquotaPIS : Double ;
                     AliquotaCOFINS : Double ;
                     AliquotaINSS : Double ;
                     AliquotaIR   : Double ;
                     AliquotaCSLL : Double ;
                     DescricaoRPS : PChar ;
                     DDDPrestador : PChar ;
                     TelefonePrestador : PChar ;
                     DDDTomador        : PChar ;
                     TelefoneTomador  : PChar ;
                     MotCancelamento : PChar ) : Integer ; external 'dms_nfse.dll';

function RPSDeducao( DeducaoPor: PChar ;
					           TipoDeducao: PChar ;
					           CPFCNPJReferencia: PChar ;
					           NumeroNFReferencia: Integer ;
					           ValorTotalReferencia: Double ;
					           PercentualDeduzir: Double ;
					           ValorDeduzir: Double  ): Integer ; external 'dms_nfse.dll';

function RPSItem( DiscriminacaoServico: PChar ;
					        Quantidade: Double ;
					        ValorUnitario: Double ;
					        ValorTotal: Double  ): Integer ; external 'dms_nfse.dll';




function EnviarDeclaracao(    DocAssinatura : PChar ;
                          var Assincrono: PChar;
                          var Sucesso : PChar ;
		                      var NumeroLote: Integer ;
                          var QtdNotasProcessadas : Integer ;
                          var ValorTotalServicos: Double ;
                          var ValorTotalDeducoes:Double;
                          var Erros: Integer;
                          var Alertas: Integer): Integer ; external 'dms_nfse.dll';

function ErrosRetorno( ErroItem:Integer;
                         var Codigo: Integer;
                         var Descricao: PChar;
                         var InscricaoPrestador : PChar;
                         var SerieRPS: PChar ;
                         var NumeroRPS: Integer;
                         var DataEmissaoRPS:PChar;
                         var RazaoSocialPrestador: PChar ):Integer; external 'dms_nfse.dll';

function AlertasRetorno( ErroItem:Integer;
                         var Codigo: Integer;
                         var Descricao: PChar;
                         var InscricaoPrestador : PChar;
                         var SerieRPS: PChar ;
                         var NumeroRPS: Integer;
                         var DataEmissaoRPS:PChar;
                         var RazaoSocialPrestador: PChar ):Integer; external 'dms_nfse.dll';
function NfseRetorno( RetornoItem : Integer ;
                     var InscricaoPrestador: PChar ;
                     var NumeroNFe: Integer ;
                     var CodigoVerificacao: PChar ;
                     var RazaoSocialPrestador: PChar ;
                     var SerieRPS : PChar ;
				             var NumeroRPS: Integer ;
				             var DataEmissaoRPS : PChar ) :Integer ; external 'dms_nfse.dll';


procedure TfrmConversao.BtnOkClick(Sender: TObject);
var
  Data : TDateTime;
  Dia, Mes, Ano : Word;
  Encontrou : Boolean;
  MesRef, MesRefIn : String;
  Pos : Integer;

  ERRO : INTEGER;

   InscricaoMunicipalPrestador: PChar ;
    RazaoSocialPrestador: PChar ;
    TipoRPS : PChar ;
    SerieRPS: PChar ;
    NumeroRPS : Integer ;
    DataEmissaoRPS : PChar ;
    SituacaoRPS : PChar ;
    SerieRPSSubstituido: PChar ;
    NumeroRPSSubstituido : Integer ;
    NumeroNFSeSubstituida : Integer ;
    DataEmissaoNFSeSubstituida : PChar ;
    SeriePrestacao: PChar ;
    InscricaoMunicipalTomador  : PChar ;
    CPFCNPJTomador  : PChar ;
    RazaoSocialTomador : PChar ;
    TipoLogradouroTomador : PChar ;
    LogradouroTomador : PChar ;
    NumeroEnderecoTomador : PChar ;
    TipoBairroTomador: PChar ;
    BairroTomador  : PChar ;
    CidadeTomador  : Integer ;
    CidadeTomadorDescricao: PChar ;
    CEPTomador : PChar ;
    EmailTomador  : PChar ;
    CodigoAtividade: PChar ;
    AliquotaAtividade : Double ;
    TipoRecolhimento  : PChar ;
    MunicipioPrestacao : Integer ;
    MunicipioPrestacaoDescricao: PChar ;
    Operacao   : PChar ;
    Tributacao : PChar ;
    ValorPIS    : Double ;
    ValorCOFINS : Double ;
    ValorINSS   : Double ;
    ValorIR     : Double ;
    ValorCSLL   : Double ;
    AliquotaPIS : Double ;
    AliquotaCOFINS : Double ;
    AliquotaINSS : Double ;
    AliquotaIR   : Double ;
    AliquotaCSLL : Double ;
    DescricaoRPS : PChar ;
    DDDPrestador : PChar ;
    TelefonePrestador : PChar ;
    DDDTomador        : PChar ;
    TelefoneTomador  : PChar ;
    MotCancelamento : PChar;
    //Quantidade de Servicos e Deducoes do RPS
    QtdServicos : Integer;
    QtdDeducoes : Integer;

    //Parametros do 3 Etapa : Itens do RPS
    DiscriminacaoServico: PChar ;
		Quantidade: Double ;
		ValorUnitario: Double ;
		ValorTotal: Double ;

    //Parametros da 3 Etapa : Deduoes da RPS
    DeducaoPor: PChar ;
		TipoDeducao: PChar ;
		CPFCNPJReferencia: PChar ;
		NumeroNFReferencia: Integer ;
		ValorTotalReferencia: Double ;
		PercentualDeduzir: Double ;
		ValorDeduzir: Double ;

    Assincrono : PChar; //Coloque A para enviou assincrono e N para envio sincrono
    DocAssinatura : Pchar;

    ValorTotalServicos: Double;
		ValorTotalDeducoes: Double;
    Sucesso: PChar ;
    NumeroLote: Integer ;
    QtdNotasProcessadas : Integer;
    Erros, Alertas : Integer ;

     //Parametros do Erro de Retorno
    CodErro: Integer;
    Descricao: PChar;
    InscricaoPrestador : PChar;

    //RPS do Retorno
    NumeroNFe: Integer ;
    CodigoVerificacao: PChar ;

    J: Integer;


begin
// COLOCA O CAMINHO DO WEBSERVICE NA DLL
  setURL( Pchar(FrmPrincipal.UrlWebService) , PChar(FrmPrincipal.UrlWebService + '?wsdl') );
  Encontrou := false;
  FrmConverterRps.QryRps.First;
  with FrmConverterRps.QryRps   do
  begin
    while not eof do
    begin
      edit;
      FieldByName('converte').AsInteger := 0;
      if ((FieldByName('NumeroNota').AsString = '') and (FieldByName('NumeroLote').AsString = '')) then
      begin       
        Data := StrToDateTime(FieldByName('DataEmissaoRps').AsString);
        DecodeDate(Data,ano,mes,dia);
        Encontrou := false;
        MesRef := IntToStr(Mes)+ '/' + IntToStr(Ano)  ;

        Pos := lstMes.Items.IndexOf(MesRef) ;
        if (Pos >= 0) then
         if LstMes.Checked[Pos] then
         begin
           FieldByName('converte').AsInteger := 1;
           Encontrou := true;
         end;
      end;
       post;
      next;
    end;
  end;
  if Encontrou = false then
  begin
    ShowMessage('No foram selecionados RPS para serem convertidos.');
    Abort;
  end;



  //A chamada da funo abaixo  opcional, no  necessario fazer chamada a ela , mais se quizer a dll ir gravar os arquivos xml gerados na pasta configurada abaixo,
  //Se no for feita nenhuma chamada a esta funo a dll no ir gravar os arquivos xml
  if frmPrincipal.CamTemp <> '' then
  if ( setGravaArquivoXML( PChar(frmPrincipal.CamTemp)  ) = 0 ) then
    showmessage('Os arquivos XML gerados sero gravados em ' + frmPrincipal.CamTemp );

  // 1 ETAPA - CRIA O LOTE DE REMESSA

  Erro:= CriarRemessa( frmPrincipal.CodCid, PChar(frmPrincipal.CpfCnpjRemetente), PChar(frmPrincipal.RazaoSocialRemetente) );

  if ( Erro <> 0 ) then  begin
    ShowMessage('Descrio do erro ocorrido na criao do lote de remessa : ' + ErroRetorno( Erro ));
    Abort;
  end ;


   // 2 ETAPA -  REGISTRO DOS RPS
  //Aqui pode ser iniciado um loop para cada RPS a ser enviada no lote
 FrmConverterRps.QryRps.First;
 with FrmConverterRps.QryRps   do
  begin
    while not eof do
    begin
      if FieldByName('converte').AsInteger = 1 then
      begin
        InscricaoMunicipalPrestador   := PChar(FieldByName('InscricaoMunicipalPrestador').AsString) ;
        RazaoSocialPrestador          := PChar(FieldByName('RazaoSocialPrestador').AsString) ;
        TipoRPS                       := PChar(FieldByName('TipoRps').AsString) ;
        SerieRPS                      := PChar(FieldByName('SerieRps').AsString) ;
        NumeroRPS                     := FieldByName('NumeroRps').AsInteger ;
        DataEmissaoRPS                := PChar(FieldByName('DataEmissaoRps').AsString );
        SituacaoRPS                   := PChar(FieldByName('SituacaoRps').AsString) ;
        SerieRPSSubstituido           := PChar(FieldByName('SerieRpsSubstituto').AsString) ;
        NumeroRPSSubstituido          := FieldByName('NumeroRpsSubstituto').AsInteger;
        NumeroNFSeSubstituida         := FieldByName('NumeroNFSeSubstituida').AsInteger ;
        DataEmissaoNFSeSubstituida    := PChar(FieldByName('DataEmissaoNFSeSubstituida').AsString );
        SeriePrestacao                := PChar(FieldByName('SeriePrestacao').AsString );
        InscricaoMunicipalTomador     := PChar(FieldByName('InscricaoMunicipalTomador').AsString) ;
        CPFCNPJTomador                := PChar(FieldByName('CpfCnpjTomador').AsString) ;
        RazaoSocialTomador            := PChar(FieldByName('RazaoSocialTomador').AsString) ;
        TipoLogradouroTomador         := PChar(FieldByName('TipoLogradouroTomador').AsString) ;
        LogradouroTomador             := PChar(FieldByName('LogradouroTomador').AsString) ;
        NumeroEnderecoTomador         := PChar(FieldByName('NumeroEnderecoTomador').AsString) ;
        TipoBairroTomador             := PChar(FieldByName('TipoBairroTomador').AsString) ;
        BairroTomador                 := PChar(FieldByName('BairroTomador').AsString) ;
        CidadeTomador                 := FieldByName('CidadeTomador').AsInteger;
        CidadeTomadorDescricao        := PChar(FieldByName('CidadeTomadorDescricao').AsString) ;
        CEPTomador                    := PChar(FieldByName('CEPTomador').AsString) ;
        EmailTomador                  := PChar(FieldByName('EmailTomador').AsString) ;
        CodigoAtividade               := PChar(FieldByName('CodigoAtividade').AsString) ;
        AliquotaAtividade             := FieldByName('AliquotaAtividade').AsCurrency;
        TipoRecolhimento              := PChar(FieldByName('TipoRecolhimento').AsString) ;
        MunicipioPrestacao            := FieldByName('MunicipioPrestacao').AsInteger;
        MunicipioPrestacaoDescricao   := PChar(FieldByName('MunicipioPrestacaoDescricao').AsString) ;
        Operacao                      := PChar(FieldByName('Operacao').AsString) ;
        Tributacao                    := PChar(FieldByName('Tributacao').AsString) ;
        ValorPIS                      := FieldByName('ValorPis').AsCurrency;
        ValorCOFINS                   := FieldByName('ValorCOFINS').AsCurrency;
        ValorINSS                     := FieldByName('ValorINSS').AsCurrency;
        ValorIR                       := FieldByName('ValorIR').AsCurrency;
        ValorCSLL                     := FieldByName('ValorCSLL').AsCurrency;
        AliquotaPIS                   := FieldByName('AliquotaPIS').AsCurrency;
        AliquotaCOFINS                := FieldByName('AliquotaCOFINS').AsCurrency;
        AliquotaINSS                  := FieldByName('AliquotaINSS').AsCurrency;
        AliquotaIR                    := FieldByName('AliquotaIR').AsCurrency;
        AliquotaCSLL                  := FieldByName('AliquotaCSLL').AsCurrency;
        DescricaoRPS                  := PChar(FieldByName('DescricaoRPS').AsString );
        DDDPrestador                  := PChar(FieldByName('DDDPrestador').AsString) ;
        TelefonePrestador             := PChar(FieldByName('TelefonePrestador').AsString );
        DDDTomador                    := PChar(FieldByName('DDDTomador').AsString) ;
        TelefoneTomador               := PChar(FieldByName('TelefoneTomador').AsString );
        MotCancelamento               := PChar(FieldByName('MotCancelamento').AsString) ;


        Erro := RPSRemessa( InscricaoMunicipalPrestador, RazaoSocialPrestador, TipoRPS, SerieRPS,
                            NumeroRPS, DataEmissaoRPS, SituacaoRPS, SerieRPSSubstituido,
                            NumeroRPSSubstituido, NumeroNFSeSubstituida, DataEmissaoNFSeSubstituida ,
                            SeriePrestacao, InscricaoMunicipalTomador, CPFCNPJTomador  ,
                            RazaoSocialTomador, TipoLogradouroTomador, LogradouroTomador ,
                            NumeroEnderecoTomador, TipoBairroTomador, BairroTomador  ,
                            CidadeTomador, CidadeTomadorDescricao, CEPTomador ,
                            EmailTomador, CodigoAtividade, AliquotaAtividade, TipoRecolhimento  ,
                            MunicipioPrestacao, MunicipioPrestacaoDescricao, Operacao   ,
                            Tributacao, ValorPIS, ValorCOFINS, ValorINSS,
                            ValorIR, ValorCSLL, AliquotaPIS, AliquotaCOFINS,
                            AliquotaINSS, AliquotaIR, AliquotaCSLL, DescricaoRPS,
                            DDDPrestador, TelefonePrestador, DDDTomador, TelefoneTomador, MotCancelamento ) ;

        if Erro <> 0 then begin
          ShowMessage( 'Erro no RPS. Descrio do Erro ' +  ErroRetorno( Erro ));
          break ; //Interompe processo
        end ;

        //3 ETAPA, adicionar os servicos da RPS,  necessrio chamar a funo do registro para cada servico da rps.
        QryAux.Close;
        QryAux.SQL.Text := 'SELECT * FROM TBLITENS WHERE CODRPS = ' + fieldbyname('codrps').AsString;
        qryaux.Open;
        while not qryaux.eof do
        begin
           DiscriminacaoServico :=  PChar(qryaux.FieldByName('DiscriminacaoServico').asString) ;
           Quantidade := qryaux.FieldByName('Quantidade').AsCurrency;
           ValorUnitario := qryaux.FieldByName('ValorUnitario').AsCurrency;
           ValorTotal :=  qryaux.FieldByName('ValorTotal').AsCurrency;

           Erro:= RPSItem( DiscriminacaoServico, Quantidade, ValorUnitario, ValorTotal) ;

           if ( Erro <> 0) then begin
             ShowMessage( 'Erro na item do RPS ' +  fieldbyname('NumeroRps').AsString + ', Descrio do Erro : ' +  ErroRetorno( Erro ));
             Break ; //Interrompe aplicacao
           end ;
           qryaux.Next;
        end;


        //FIM DA 3 ETAPA

        //4 ETAPA - adicionar dedues da remessa, caso tenha deduoes
        QryAux.Close;
        QryAux.SQL.Text := 'SELECT * FROM TBLdeducao WHERE CODRPS = ' + fieldbyname('codrps').AsString;
        qryaux.Open;
        while not qryaux.eof do
        begin
            DeducaoPor  :=    PChar(qryaux.FieldByName('DeducaoPor').AsString) ;
            TipoDeducao  :=   PChar(qryaux.FieldByName('TipoDeducao').AsString) ;
            CPFCNPJReferencia    := Pchar(qryaux.FieldByName('CPFCnpjReferencia').AsString) ;
            NumeroNFReferencia   := qryaux.FieldByName('NumeroNFReferencia').AsInteger;
            ValorTotalReferencia := qryaux.FieldByName('ValorTotalReferencia').AsCurrency;
            PercentualDeduzir    := qryaux.FieldByName('PercentualDeduzir').AsCurrency;
            ValorDeduzir         := qryaux.FieldByName('ValorDeduzir').AsCurrency;

            Erro := RPSDeducao( DeducaoPor, TipoDeducao, CPFCNPJReferencia, NumeroNFReferencia,
                                ValorTotalReferencia, PercentualDeduzir, ValorDeduzir  ) ;

            if ( Erro <> 0 ) then begin
              ShowMessage( 'Erro na deduo do RPS ' +  fieldbyname('NumeroRps').AsString + ', Descrio do Erro : ' +  ErroRetorno( Erro ));
              Break; //Interrompe aplicao
            end ;
            qryaux.Next;
        end;

        //FIM DA 4 ETAPA
        //FIM DA 2 ETAPA

  End; //aqui pode ser finalizado o loop que rota todas as RPS a serem enviadas
  next;
  END;
  //FIM DA 1 ETAPA

  //5 ETAPA - FECHA LOTE E ENVIA DECLARAO, NESTA ETAPA IRA RETORNAR TRUE PARA SUCESSO, CASO O RETONO TENHA SIDO ASSINCRONO ELE RETORNA FALSO
  //E O NUMERO DE LOTE GERADO COM OS DEMAIS DADOS

  Assincrono := 'A' ; //Coloque A para enviou assincrono e N para envio sincrono
  if chkassina.Checked then
    DocAssinatura := PChar(frmPrincipal.CpfCnpjRemetente)
    else
    DocAssinatura := '';

  Erro := EnviarDeclaracao( DocAssinatura, Assincrono, Sucesso, NumeroLote, QtdNotasProcessadas,
                            ValorTotalServicos, ValorTotalDeducoes, Erros, Alertas );

  if Erro <> 0 then begin
    ShowMessage( 'Erro ao Enviar Declarao.  Descrio : '  + ErroRetorno( Erro ) ) ;
    Abort;
  end else
  begin //GRAVA O NUMERO DO LOTE GERADO
  FrmConverterRps.QryRps.First;
  with FrmConverterRps.QryRps   do
  begin
   while not eof do
   begin
     edit;
     if fieldbyname('converte').AsInteger = 1 then
       fieldbyname('NumeroLote').AsInteger := NumeroLote;
     post;
     next;
   end;

  end;


  end;

  ShowMessage('Lote Gerado : ' + IntToStr( NumeroLote ) + '  Notas Processadas : '  +  IntToStr( QtdNotasProcessadas ) + ' Erros : ' + IntToStr(Erros));
  //6 ETAPA - PEGA ERROS E ALERTAS DO PROCESSAMENTO
  if Erros > 0 then begin
     for j := 0 to Erros - 1 do begin
     Erro := ErrosRetorno( J, CodErro, Descricao, InscricaoPrestador, SerieRPS,
                           NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
     if Erro = 0  then
       ShowMessage('Erro : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
     end ;
  end;

   if Alertas > 0 then begin
     for j := 0 to Alertas - 1 do begin
     Erro := AlertasRetorno( J, CodErro, Descricao, InscricaoPrestador,
                             SerieRPS, NumeroRPS, DataEmissaoRPS, RazaoSocialPrestador ) ;
     if Erro = 0  then
       ShowMessage('Alerta : ' + IntToStr( CodErro ) + ' - ' + Descricao + ' RPS: = ' + IntToStr( NumeroRPS ));
     end ;
  end;
  //7 ETAPA PEGA OS DADOS DAS NOTAS PROCESSADAS.
  //OBS: CASO O RETONO SEJA ASSINCRONO SERA RETORNADO A QUANTIDADE DE NOTAS PROCESSADAS IGUAL A ZERO, E SE DEVE USAR O CONSULTA LOTE PARA VERIFICAR O PROCESSAMENTO.
  if QtdNotasProcessadas > 0 then
    for j  := 0 to QtdNotasProcessadas - 1 do begin
    Erro :=  NfseRetorno( j, InscricaoPrestador, NumeroNFe, CodigoVerificacao,
                         RazaoSocialPrestador, SerieRPS ,NumeroRPS, DataEmissaoRPS );
    if Erro <> 0 then
      ShowMessage('Erro ao consultar RPS ' + ErroRetorno( Erro ))
      else begin
      ShowMessage('RPS ' + IntToStr( NumeroRps) + ' NFSe: ' + IntToStr(NumeroNFe) + ' gerada.')
    end ;
    end;
  end;




end;

procedure TfrmConversao.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  frmConversao := nil;
end;

procedure TfrmConversao.FormShow(Sender: TObject);

var
  Data: TDateTime;
  Dia,
   Mes,
  Ano : Word;
  Encontrou: Boolean;
  MesRef , MesRefIn: String;
  i: Integer;
begin
  QryAux.close;
  qryaux.SQL.text := 'SELECT DataEmissaoRps, NumeroRps from TblRps WHERE NumeroNota IS NULL AND NumeroLote is null';
  qryaux.Open;
  while not qryaux.Eof do
  begin
  try
     Data := StrToDateTime(QryAux.FieldByName('DataEmissaoRps').AsString);
     DecodeDate(Data,ano,mes,dia);
     Encontrou := false;
     MesRef := IntToStr(Mes)+ '/' + IntToStr(Ano)  ;
     for I := 0 to lstMes.Count - 1 do
     begin
        if lstMes.Items.ValueFromIndex[I] = MesRef then
        begin
          Encontrou := true;
          Break;
        end;

     end;
     if encontrou = false then
       LstMes.Items.Add(MesRef);

  except on E: Exception do
    ShowMessage('Data do RPS ' +  QryAux.FieldByName('NumeroRps').AsString + ' invlida');
  end;
    qryaux.Next;

  end;
end;

end.
